/**
@file
@verbatim
$Id: DivXPortable.h 4762 2005-10-28 12:50:22Z jfunnell $

Copyright (c) 2000-2005 DivX, Inc. All rights reserved.

This software is the confidential and proprietary information of DivX, Inc.,
Inc. and may be used only in accordance with the terms of your license from
DivX, Inc.

@endverbatim
This file contains platform-specific definitions (typedefs or macros) of 
integer types such as int32_t.
@brief Integer types and memory alignment
*/


#ifndef _Q_DivXPortable_h
#define _Q_DivXPortable_h

/* by default, this directive means nothing */
#define __ALIGNED

#if defined(WIN32) || defined(DOXYGEN)

/* basic types
*/
#ifndef NULL
#ifdef  __cplusplus
#define NULL    0
#else
#define NULL    ((void *)0)
#endif
#endif

typedef char int8_t;
typedef unsigned char uint8_t;
typedef short int16_t;
typedef unsigned short uint16_t;
typedef int int32_t;
typedef unsigned int  uint32_t;
typedef __int64 int64_t;
typedef unsigned __int64 uint64_t;

#define SU_MALLOC_ALIGN_SIZE    64

//#ifdef __INTEL_COMPILER
#undef __ALIGNED 
//#define __ALIGNED __declspec(align(32))
#define __ALIGNED __declspec(align(128))
//#endif

#elif defined (TARGET_PS2)

typedef char int8_t;
typedef unsigned char uint8_t;
typedef short int16_t;
typedef unsigned short uint16_t;
typedef int int32_t;
typedef unsigned int  uint32_t;
typedef signed long         int64_t;
typedef unsigned long uint64_t;

#define SU_MALLOC_ALIGN_SIZE    32

#elif defined (ARCH_BSP_V60)

#include <inttypes.h>
#define memcpy unaligned_memcpy
#define SU_MALLOC_ALIGN_SIZE    128

#elif defined (ARCH_TI_C6000)
#define ARCH_TI

#define __inline
#define SU_MALLOC_ALIGN_SIZE    64

typedef char int8_t;
#define __int8_t_defined
typedef unsigned char uint8_t;
typedef short int16_t;
typedef unsigned short uint16_t;
typedef int int32_t;
typedef unsigned int  uint32_t;
typedef double int64_t;
typedef double uint64_t;

#elif defined (ARCH_TI_C5000)
#define ARCH_TI
#define __inline
#define SU_MALLOC_ALIGN_SIZE    64

typedef char int8_t;
#define __int8_t_defined
typedef unsigned char uint8_t;
typedef short int16_t;
typedef unsigned short uint16_t;
typedef int int32_t;
typedef unsigned int  uint32_t;
#error The following two typedefs are almost certainly incorrect and need review.
typedef double int64_t;
typedef double uint64_t;

#elif defined (__CYGWIN__)
#include "sys/types.h"
#define SU_MALLOC_ALIGN_SIZE    128

#elif defined (LINUX)

#include <inttypes.h>
#define SU_MALLOC_ALIGN_SIZE    128
#undef __ALIGNED
#define __ALIGNED __attribute__((__aligned__(16)))

#else // WIN32

#include <inttypes.h>
#define SU_MALLOC_ALIGN_SIZE    128

#endif 

#ifdef WIN32
#define CONSTANT_64BIT(X) X ## i64
#else
#define CONSTANT_64BIT(X) X ## LL
#endif

#endif // _Q_DivXPortable_h
