/**
@file
@verbatim
$Id: FrameInput.h 3096 2005-06-21 20:07:11Z ekuznetsov $

Copyright (c) 2002-2004 DivX, Inc. All rights reserved.

This software is the confidential and proprietary information of DivX, Inc.,
Inc. and may be used only in accordance with the terms of your license from
DivX, Inc.

@endverbatim
*/

#ifndef _Q_FrameInput_h
#define _Q_FrameInput_h

/// Video frame for input to the encoder.  Allows for representation of 
/// interlaced frames within the encoder by separate frame pointers for top
/// and bottom fields.  In many cases, frameT and frameB will be pointing
/// at the same image.
class FrameInput
{
public:
    /// Image pointer used for even lines (top field).
    unsigned char* imageT;

    /// Image pointer used for odd lines (bottom field).
    unsigned char* imageB;

    /// Display timestamp of the frame.
    int timestampDisplay;
};

#endif 
