/**
@file
@verbatim
$Id: FrameResult.h 3096 2005-06-21 20:07:11Z ekuznetsov $

Copyright (c) 2004 DivX, Inc. All rights reserved.

This software is the confidential and proprietary information of DivX, Inc.,
Inc. and may be used only in accordance with the terms of your license from
DivX, Inc.

@endverbatim
*/


#ifndef _ENCORE_FrameResult
#define _ENCORE_FrameResult

/// Result of encoding a frame returned to the user and uesd internally within the
/// encoder for rate control.
/// Optional information (everything that can be discared by the user without dire consequences).
typedef struct FrameResult
{
    int bitcountMotion;       ///< Number of bits of encoded frame used for describing motion.
    int bitcountTexture;      ///< Number of bits of encoded frame used for describing texture.
    int bitcountStuffing;     ///< Number of bits of encoded frame used by stuffing.
    int bitcountTotal;        ///< Total number of bits in encoded frame.
    int quantizer;            ///< Actual frame-level quantizer used to encode frame.
    int sequenceNumber;       ///< Display-order sequence number of encoded frame.

    int motionVectorSum;      ///< Sum of logarithms of motion vector magnitudes
    int motionVectorCount;    ///< Count of motion vectors used to generate motionVectorSum.

    char frameType;           ///< Actual frame-type ('I'/'B'/'P') of encoded frame. cType=0 means no frame produced. */
    int timestampDisplay;     ///< Display/composition timestamp of encoded frame.
    float psnr;               ///< PSNR of encoded frame.  If zero or negative, PSNR is unavailable.
} 
FrameResult;


#endif

